import os
import urllib

import sys


def tisbackup_list(url):
    # List from srvtisbackup GUI
    try:
        layout = urllib.urlopen(url).read()
    except Exception as e:
        raise Exception("Tisbackup url: " + str(e))
    if not '[' in layout:
        raise Exception("Tisbackup url malform: " + url)

    templist = layout.split(']')
    row = 0
    for _ in templist:
        templist[row] = templist[row].translate(None, '["')
        if row > 0:
            templist[row] = templist[row][2:]
        row += 1
    ip_list = []
    row = 0
    for _ in [x for x in templist if x ]:
        ip_list.append(
            [(templist[row].split(',')[0]), (templist[row].split(',')[1][1:]), (templist[row].split(',')[2][1:]),
             (templist[row].split(',')[3][1:])])
        row += 1
    return ip_list


def check_backup(ip_list, backup_list, nagiosState):
    result_dict = {'warn': nagiosState['ok'], 'title': "Backup"}
    name_list = []
    server_list = []
    bad_list = []
    try:
        for host in ip_list:
            if not host.exclude:
                name_list.append([host.name_ptr.split(".")[0], host.ip])
        for row in backup_list:
            server_list.append(row[0])

        for server in name_list:
            if (server[1] not in server_list) and (server[0] not in server_list):
                if server[0] == "":
                    bad_list.append(server[1])
                else:
                    bad_list.append(server[0])

        result_dict['list'] = bad_list
        result_dict['messages'] = " are not registered for backup from srvbackup"
        result_dict['message'] = " is not registered from srvbackup"
        if len(bad_list) > 0:
            result_dict['warn'] = nagiosState['warning']

    except StandardError, message:
        result_dict['message'] = "%s : error %s" % (os.path.basename(sys.argv[0]), message)
        result_dict['warn'] = nagiosState['unknown']

    return result_dict
