import os
import sys
import urllib
import urllib2


def check_ip_nagios(ip_list, nagios_list, nagiosState):
    check_ip_list = []
    result_dict = {'warn': nagiosState['ok'], 'title': "Nagios"}
    bad_list = []

    try:
        for host in ip_list:
            if not host.exclude:
                check_ip_list.append(host.ip)
        for ip in check_ip_list:
            if ip not in nagios_list:
                octet = ip.split(".")[2] + "." + ip.split(".")[3]
                bad_list.append(octet)

        result_dict['list'] = bad_list
        result_dict['messages'] = " are not registered in nagios configuration"
        result_dict['message'] = " is not registered in nagios configuration"
        if len(bad_list) > 0:
            result_dict['warn'] = nagiosState['warning']


    except StandardError, message:
        result_dict['message'] = "%s : error %s" % (os.path.basename(sys.argv[0]), message)
        result_dict['warn'] = nagiosState['unknown']

    return result_dict


def audit_list(url):
    # List from network audit
    try:
        layout = urllib.urlopen(url).read()
    except Exception as e:
        raise Exception("Nagios url: " + str(e))
    if not '[' in layout:
        raise Exception("Nagios url malform: " + url)
    templist = layout.split(']')
    row = 0
    for _ in templist:
        templist[row] = templist[row].translate(None, '["')
        if row > 0:
            templist[row] = templist[row][2:]
        row += 1
    templist.remove('')
    templist.remove('')
    ip_list = []
    row = 0
    for _ in templist:
        ip_list.append(
            [(templist[row].split(',')[0]), (templist[row].split(',')[1][1:]), (templist[row].split(',')[2][1:]),
             (templist[row].split(',')[3][1:])])
        row += 1
    return ip_list


def mk_list(zone, nagiosuser, nagiospasswd):
    # List from check_mk
    password_mgr = urllib2.HTTPPasswordMgrWithDefaultRealm()
    top_level_url = "http://srvnagios/check_mk/"
    password_mgr.add_password(None, top_level_url, nagiosuser, nagiospasswd)
    handler = urllib2.HTTPBasicAuthHandler(password_mgr)
    opener = urllib2.build_opener(handler)

    url = "http://srvnagios/check_mk/view.py?view_name=all_ip&host=" + zone + "&output_format=json"
    try:
        layout = opener.open(url).read()
    except Exception as e:
        raise Exception("checkmk: " + str(e))

    if 'ERROR' in layout:
        raise Exception("CheckMk: " + layout)
    templist = layout.split(']')
    row = 0
    for _ in templist:
        templist[row] = templist[row].translate(None, '["')
        if row > 0:
            templist[row] = templist[row][2:]
        row += 1
    templist.remove('')
    templist.remove('')
    nagios_list = []
    row = 0
    for _ in templist:
        nagios_list.append(templist[row].split(',')[1])
        row += 1
    return nagios_list
