#!/usr/bin/python
# -*- coding: utf8 -*-
import urllib2
import sys
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('-H', '--host', help='The address of the host running the nrpeweb daemon', required=True)
parser.add_argument('-p', '--port', help='The port on which the daemon is running (default=5667)', type=int,
                    default=5667)
parser.add_argument('-t', '--timeout', help='Number of seconds before connection times out (default=5)', type=int,
                    default=5)
parser.add_argument('-c', '--command', help='The name of the command that the remote daemon should run', required=True)
parser.add_argument('-a', '--arglist', help='Optional arguments that should be passed to the command)')
args = parser.parse_args()
host = args.host
command = args.command
timeout = args.timeout
port = args.port

try:
    response = urllib2.urlopen("http://%s:%s/check/%s" % (host, port, command), timeout=timeout)
    status = response.info()['X-NRPE-STATUS']
    if status not in ['0', '1', '2', '3']:
        print "error, wrong return code  %s " % status
        raise Exception()
    status = int(status)

    content = response.read()
    print content.strip()
    sys.exit(status)

except Exception as e:
    print "error while processing %s " % e
    raise Exception()
