def check_wapt(network_list):
    """
    Basic impl. : if host OS is Windows and
    port 8088 not listening, we assume that
    it doesn't have WAPT.
    Returns a comma-separated string.
    """
    result_dict = {'title': "WAPT"}

    hosts = []
    for host in network_list:
        if "windows" in host.guest_os.lower():
            if '8088' not in host.ports:
                hosts.append(host)
    result_dict['list'] = [
        "{} ({})".format(host.name_ptr, host.ip) for host in hosts
    ]
    result_dict['messages'] = "are not compliant."

    return result_dict
