import os
import subprocess
import sys
import urllib2


def check_windows_update_settings(network_list, nagiosState):
    result_dict = {'warn': nagiosState['ok'], 'title': "Windows update settings"}
    bad_list = []

    try:
        for ip in network_list:
            cmd = subprocess.call([os.path.abspath('.')+'/libtiscompliance/check_nrpe_web.py', '-t', '5', '-H', ip[1], '-c',
                                   'check_windows_updates_settings'], stdout=open('/dev/null', 'w'),
                                  stderr=subprocess.STDOUT, shell=True)
            if cmd != 0:
                bad_list.append(ip[0])

        result_dict['list'] = bad_list
        result_dict['messages'] = " are not comply with windows update settings."
        result_dict['message'] = " is not comply with windows update settings."
        if len(bad_list) > 0:
            result_dict['warn'] = nagiosState['warning']


    except StandardError, message:
        result_dict['message'] = "%s : error %s" % (os.path.basename(sys.argv[0]), message)
        result_dict['warn'] = nagiosState['unknown']

    return result_dict


def check_windows_searchindexer(network_list, nagiosState):
    result_dict = {'warn': nagiosState['ok'], 'title': "Windows Searchindexer"}
    bad_list = []

    try:
        for ip in network_list:
            cmd = subprocess.call([os.path.abspath('.')+'/libtiscompliance/check_nrpe_web.py', '-t', '5', '-H', ip[1], '-c',
                                   'check_searchindexer'], stdout=open('/dev/null', 'w'), stderr=subprocess.STDOUT, shell=True)
            if cmd != 0:
                bad_list.append(ip[0])

        result_dict['list'] = bad_list
        result_dict['messages'] = " are not comply with windows searchindexer."
        result_dict['message'] = " is not comply with windows searchindexer."
        if len(bad_list) > 0:
            result_dict['warn'] = nagiosState['warning']


    except StandardError, message:
        result_dict['message'] = "%s : error %s" % (os.path.basename(sys.argv[0]), message)
        result_dict['warn'] = nagiosState['unknown']

    return result_dict


def srvwindows_list(zone, nagiosuser, nagiospasswd):
    # List from check_mk
    password_mgr = urllib2.HTTPPasswordMgrWithDefaultRealm()
    top_level_url = "http://srvnagios/check_mk/"
    password_mgr.add_password(None, top_level_url, nagiosuser, nagiospasswd)
    handler = urllib2.HTTPBasicAuthHandler(password_mgr)
    opener = urllib2.build_opener(handler)
    url = "http://srvnagios/check_mk/view.py?view_name=all_ip&opthost_group=srvwin&host=" + zone + "&output_format=json"
    try:
        layout = opener.open(url).read()
    except Exception as e:
        raise Exception("checkmk: " + str(e))

    if 'ERROR' in layout:
        raise Exception("CheckMk: " + layout)

    return eval(layout)[1:]
